//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%38CD1AF1E4F8.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%38CD1AF1E4F8.cm

//## begin module%38CD1AF1E4F8.cp preserve=no
//## end module%38CD1AF1E4F8.cp

//## Module: XSstream%38CD1AF1E4F8; Package body
//## Subsystem: XSUtil::Utils%3777E01D9D80
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/Utils/XSstream.cxx

//## begin module%38CD1AF1E4F8.additionalIncludes preserve=no
//## end module%38CD1AF1E4F8.additionalIncludes

//## begin module%38CD1AF1E4F8.includes preserve=yes
//## end module%38CD1AF1E4F8.includes

// XSstream
#include <XSUtil/Utils/XSstream.h>


//## begin module%38CD1AF1E4F8.declarations preserve=no
//## end module%38CD1AF1E4F8.declarations

//## begin module%38CD1AF1E4F8.additionalDeclarations preserve=yes
#include <XSstreams.h>
#include <XSUtil/Utils/IosHolder.h>
#include <typeinfo>
#include <cstring>
using std::streambuf;

XSstream tpout;
XSstream tperr;
XSstream tpcon;
XSstream tpin;

const size_t NORM_OUTPUT =  10;      
//## end module%38CD1AF1E4F8.additionalDeclarations


// Class XSstreambuf 

XSstreambuf::XSstreambuf()
  //## begin XSstreambuf::XSstreambuf%3898889BE8F0_const.hasinit preserve=no
      : m_unbuffered(false),
        m_charTaken(false),
        m_ch('\0'),
        m_pbChars(4),
        m_bufLen(0),
        m_buffer(0)
  //## end XSstreambuf::XSstreambuf%3898889BE8F0_const.hasinit
  //## begin XSstreambuf::XSstreambuf%3898889BE8F0_const.initialization preserve=yes
  //## end XSstreambuf::XSstreambuf%3898889BE8F0_const.initialization
{
  //## begin XSstreambuf::XSstreambuf%3898889BE8F0_const.body preserve=yes
   m_channel = 0;
  //## end XSstreambuf::XSstreambuf%3898889BE8F0_const.body
}

XSstreambuf::XSstreambuf (XSchannel* chan, std::streamsize bufferLen)
  //## begin XSstreambuf::XSstreambuf%38988F77ED60.hasinit preserve=no
      : m_unbuffered(false),
        m_charTaken(false),
        m_ch('\0'),
        m_pbChars(4),
        m_bufLen(0),
        m_buffer(0)
  //## end XSstreambuf::XSstreambuf%38988F77ED60.hasinit
  //## begin XSstreambuf::XSstreambuf%38988F77ED60.initialization preserve=yes
  //## end XSstreambuf::XSstreambuf%38988F77ED60.initialization
{
  //## begin XSstreambuf::XSstreambuf%38988F77ED60.body preserve=yes
    m_channel = 0;
    if (bufferLen > 0)
    {
        setbuf(new char[bufferLen],bufferLen);
        bufLen(bufferLen);
    }
    else if (bufferLen < 0)
    {
        setbuf(new char[-bufferLen],-bufferLen);
        bufLen(-bufferLen);
    }
    else
    {
        setbuf(0,0); // no buffering
    }
    sync();
  //## end XSstreambuf::XSstreambuf%38988F77ED60.body
}


XSstreambuf::~XSstreambuf()
{
  //## begin XSstreambuf::~XSstreambuf%3898889BE8F0_dest.body preserve=yes
    sync();
    
    delete [] m_buffer;
    delete m_channel;
  //## end XSstreambuf::~XSstreambuf%3898889BE8F0_dest.body
}



//## Other Operations (implementation)
int XSstreambuf::sync ()
{
  //## begin XSstreambuf::sync%38988EA672E0.body preserve=yes
    // if this is the streambuf for an input stream
    if ( gptr() && egptr() > gptr() ) return EOF;


    // if this is the streambuf for an output stream
    // flush waiting output
    if ( pptr() && pptr() > pbase() ) return bufferOut();

    // if there's nothing in the buffers, return 0.
    return 0;
  //## end XSstreambuf::sync%38988EA672E0.body
}

int XSstreambuf::overflow (int c)
{
  //## begin XSstreambuf::overflow%38988ECCD6C0.body preserve=yes

    if ( bufferOut() < 0)
    {
        return traits_type::eof();       
            
    }    
    else
    {
        // the following handles the case where the buffer is full,
        // which means that unbuffered output always executes starting here.
        char ca[] = {c};
        return channel()->toDevice(ca,1);
        // if the buffer has just been emptied into the channel, the following
        // updates the buffer pointer.

        // if c is not 'end of file', put the character using
        // sputc. If it is, return 0 (do nothing).

        // sputc(c) puts c into the buffer, increments the
        // buffer pointer and returns
        // the contents of the current buffer position.
        // sputc recursively calls overflow if there is no
        // room in the buffer, so this eventually terminates
        // when the EOF character is supplied to sputc.        
        if (!traits_type::eq_int_type(c,traits_type::eof())) 
        {
         	return sputc(c);
               
        }
        else
        {
                return traits_type::not_eof(c);
        }     
    }



  //## end XSstreambuf::overflow%38988ECCD6C0.body
}

std::streambuf* XSstreambuf::setbuf (char* s, std::streamsize n)
{
  //## begin XSstreambuf::setbuf%38AC2246FAE0.body preserve=yes
   // This is intended to be called only once per XSstreambuf
   // object lifetime.  Just to be safe though, delete any
   // previously allocated buffer and reset the pointer
   // positions for the unused direction to 0.
   
   
  if (n >= 0)
  {     if (s != 0 && n > 0) 
	{
	   setp(s,s+n); // output, buffered
           
           delete [] m_buffer;
           m_buffer = s;
           setg(0,0,0);
	}
        else
        {
            setp(0,0); // output, unbuffered
            unbuffered(true);
        }
  }
  else
  {
        if (s != 0) 
        {
           setg(s+pbChars(),s+pbChars(),s+pbChars());
           
           delete [] m_buffer;
           m_buffer = s;
           setp(0,0);
        }
        else
        {
            setg(0,0,0); // unbuffered input
            unbuffered(true);
        }
  }
  //## end XSstreambuf::setbuf%38AC2246FAE0.body

  return this;
}

void XSstreambuf::setChannel (XSchannel* channel, std::streamsize bufferLen, XSstream* parent)
{
  //## begin XSstreambuf::setChannel%38B6A13B1A18.body preserve=yes
  m_channel = channel;
  m_channel->stream(parent);

  if (bufferLen != 0)  // buffered I/O
  {
        // if bufferLen < 0, setbuf sets up a get buffer.
        // if bufferLen > 0, setbuf makes a put buffer.
        // bidirectional streams are not supported, but XSstreambuf can be
        // used to construct streams going in either direction.
        if (bufferLen > 0 ) 
        {
            setbuf(new char[bufferLen],bufferLen);
            bufLen(bufferLen);
        }
        else
        {
            setbuf(new char[-bufferLen],bufferLen);
            bufLen(-bufferLen);
        }
  }
  else setbuf(0,0); // do nothing
  sync();  
  //## end XSstreambuf::setChannel%38B6A13B1A18.body
}

int XSstreambuf::uflow ()
{
  //## begin XSstreambuf::uflow%38BEB7500668.body preserve=yes
        // return the character stored as m_ch if there's a character stored,
        // and set the charTaken flag to false, so that a read will be forced
        // on the next call.
        // otherwise, get a character from the device using channel()->read(&c)
        // ... read is declared as XSchannel::read(char* c, size_t n = 1)...
        // and set the charTaken() flag to true, and then return the character.
        // uflow is not required for buffered input.
        if (unbuffered())
                if (charTaken())
                {
                        charTaken(false);
                        return ch();
                }
                else
                {
                        char c = '\0';
                        if (channel()->read(&c) < 0) return EOF;
                        else
                        {
                                ch(c);
                                return c;
                        }
                }
        // use default implementation for uflow in the case of buffered input.
        else 
        {
                return streambuf::uflow();
        }
  //## end XSstreambuf::uflow%38BEB7500668.body
}

int XSstreambuf::underflow ()
{
  //## begin XSstreambuf::underflow%38BEB82C2D10.body preserve=yes
  if (unbuffered())
  {
        // return the character stored as m_ch if there's a character stored.
        // otherwise, get a character from the device using channel()->read(&c)
        // ... read is declared as XSchannel::read(char* c, size_t n = 1)...
        // and set the charTaken() flag to true, and then return the character.
        if (charTaken())
        {
                return ch();
        }
        else
        {
                char c = '\0';
                if ( channel()->read(&c) < 0 ) return EOF;
                else
                {
                        charTaken(true);
                        ch(c);
                        return c;
                }
        }
  }
  else
  {
         if ( gptr() < egptr() ) return *gptr();

         if (fillBuffer() < 0)
         {
                return EOF;
         }
         else
         {
                return *gptr();
         }
  }  
  //## end XSstreambuf::underflow%38BEB82C2D10.body
}

int XSstreambuf::pbackfail (int c)
{
  //## begin XSstreambuf::pbackfail%38C95759CCE8.body preserve=yes
  // pbackfail is called when putback operations fail to return
  // a character.

  // This implementation only supports putting back /rereading from the
  // buffer, not the channel.
  if (unbuffered())
  {
        // putback will fail if we reached the start of the buffer.
        // it will return the character or EOF if the putback character
        // has already been retrieved (no buffering allows only one putback).

        if (!charTaken())
        {
                if (c != EOF) ch(c);
                charTaken(true);
                return ch();
        }
        else
        {
                return EOF;
        }

  }
  else
  {
        // if we are here then the last consumed character can be made availabe
        // from the buffer. This is the case of the get area's next pointer is
        // not at the beginning of the buffer. Then, pbackfail() moves the get pointer
        // back one space and puts the input character c there. If c == EOF, it
        // just returns.
        if ( gptr() != eback() )
        {
                gbump(-1);
                if ( c != EOF ) *(gptr()) = c;
                return 0;
        }
        else return EOF;

  }
  //## end XSstreambuf::pbackfail%38C95759CCE8.body
}

int XSstreambuf::fillBuffer ()
{
  //## begin XSstreambuf::fillBuffer%38CD0FD98AC0.body preserve=yes
    // From Langer & Kreft, p.241
    // fillBuffer() is called by underflow/uflow to refill the buffer
    // in *buffered* input. The putback machinery is provided, and will
    // support limited putback operations on the stream.
    std::streamsize nPutback = std::min(gptr() - eback(),static_cast<ptrdiff_t>(m_pbChars));

    // copy up to pbChars() characters into the putback area, of size pbChars()
    std::memmove(m_buffer +  (pbChars() - nPutback)*sizeof(char),
                gptr()  - nPutback*sizeof(char),
                nPutback*sizeof(char) );
    int nchars = channel()->read(m_buffer+pbChars()*sizeof(char), 
                                bufLen() - pbChars());
    if (nchars < 0)
    {
        setg(0,0,0);
        return -1;
    }
    else
    {
        setg(m_buffer+pbChars() - nPutback,
             m_buffer+pbChars(),
             m_buffer+pbChars() + nchars);
    }
    return nchars;  
  //## end XSstreambuf::fillBuffer%38CD0FD98AC0.body
}

void XSstreambuf::setChannelPrompt (const std::string& ps)
{
  //## begin XSstreambuf::setChannelPrompt%38D2B19AD918.body preserve=yes
  channel()->setPrompt(ps);
  //## end XSstreambuf::setChannelPrompt%38D2B19AD918.body
}

void XSstreambuf::setChannelPrompt (const std::string& ps, const std::vector<std::string>& prompts, const std::vector<std::string>& infos)
{
  //## begin XSstreambuf::setChannelPrompt%38E2753507F8.body preserve=yes
  //## end XSstreambuf::setChannelPrompt%38E2753507F8.body
}

std::streamsize XSstreambuf::bufferOut ()
{
  //## begin XSstreambuf::bufferOut%3BA661C6015E.body preserve=yes
  if (unbuffered()) return 0;
  else
  {      
        int cw(pptr() - pbase());
        int nchars(channel()->toDevice(pbase(),cw));
        // bump the pointer whether output takes place in toDevice
        // or not: this takes care of terse output.
        pbump(-cw);
        return nchars;
  }
  //## end XSstreambuf::bufferOut%3BA661C6015E.body
}

// Class XSstream::NotXSstream 

XSstream::NotXSstream::NotXSstream()
  //## begin NotXSstream::NotXSstream%3BA0DCFA002A_const.initialization preserve=yes
  : YellowAlert(" Input stream is not capable of this function ")
  //## end NotXSstream::NotXSstream%3BA0DCFA002A_const.initialization
{
  //## begin XSstream::NotXSstream::NotXSstream%3BA0DCFA002A_const.body preserve=yes
  //## end XSstream::NotXSstream::NotXSstream%3BA0DCFA002A_const.body
}


// Class XSstream 

XSstream::XSstream()
  //## begin XSstream::XSstream%389887EE8DE0_const.hasinit preserve=yes
  : std::iostream(new XSstreambuf),
    m_conVerbose(NORM_OUTPUT),
    m_logVerbose(NORM_OUTPUT),
    m_consoleChatterLevel(NORM_OUTPUT),
    m_logChatterLevel(NORM_OUTPUT)
  //## end XSstream::XSstream%389887EE8DE0_const.hasinit
  //## begin XSstream::XSstream%389887EE8DE0_const.initialization preserve=yes
  //## end XSstream::XSstream%389887EE8DE0_const.initialization
{
  //## begin XSstream::XSstream%389887EE8DE0_const.body preserve=yes
    XSstreambuf* buffer = dynamic_cast<XSstreambuf*>(rdbuf());
    init(buffer);
  //## end XSstream::XSstream%389887EE8DE0_const.body
}

XSstream::XSstream (XSchannel* chan, std::streamsize bufferLen)
  //## begin XSstream::XSstream%389894081AD0.hasinit preserve=yes
  : std::iostream(new XSstreambuf),
    m_conVerbose(NORM_OUTPUT),
    m_logVerbose(NORM_OUTPUT),
    m_consoleChatterLevel(NORM_OUTPUT),
    m_logChatterLevel(NORM_OUTPUT)
  //## end XSstream::XSstream%389894081AD0.hasinit
  //## begin XSstream::XSstream%389894081AD0.initialization preserve=yes
  //## end XSstream::XSstream%389894081AD0.initialization
{
  //## begin XSstream::XSstream%389894081AD0.body preserve=yes
    XSstreambuf* buffer = dynamic_cast<XSstreambuf*>(rdbuf());
    init(buffer);
    buffer->setChannel(chan,bufferLen,this);
  //## end XSstream::XSstream%389894081AD0.body
}


XSstream::~XSstream()
{
  //## begin XSstream::~XSstream%389887EE8DE0_dest.body preserve=yes
   delete rdbuf();
  //## end XSstream::~XSstream%389887EE8DE0_dest.body
}



//## Other Operations (implementation)
void XSstream::defineChannel (XSchannel* chan, std::streamsize bufLen)
{
  //## begin XSstream::defineChannel%38B697943F90.body preserve=yes
    XSstreambuf* buffer = dynamic_cast<XSstreambuf*>(rdbuf());
    buffer->setChannel(chan,bufLen,this);
  //m_buf->setChannel(chan,bufLen,this);
        
        
  //m_buf = initbuf(m_buf);
  //m_buf->setChannel(chan,bufLen,this);
  //## end XSstream::defineChannel%38B697943F90.body
}

void XSstream::setPrompter (std::istream& s, const std::string& ps)
{
  //## begin XSstream::setPrompter%38D29178A0F0.body preserve=yes
  // write the prompt to the tied output stream, if there is one,
  // otherwise call the stream channel's setPrompt function.
  
    
  // tie() returns a pointer to the stream tied to s. 
  // Doing this this way with a static function allows me to hide the static
  // cast inside this routine.
  // The calling code will compile if s is any object inheriting from
  // istream, and therefore iostream (i.e. an XSstream).
    
  if ( s.tie() ) 
  {
//           *(s.tie()) << ps;  
        XSstreambuf* buffer = dynamic_cast<XSstreambuf*>(s.rdbuf());
        buffer->setChannelPrompt(ps);
  }
  else
  {
  // note that in the case of tied streams, the XSstream deals with
  // the prompting, but in the case of the GUI output the channel deals
  // with it.
       
        // This passes the input string down to the channel's prompting mechanism.
        // Actually, this is quite specific for TkIO, for which the
        // output is "prompted" by a tk script. 
      
        // More accurately it's specific to XSchannels  whose user interface is 
        // implemented by anything that's described by a string.
      
        // for Tk, there are no channels, so we will end up here.
        // This code however places a requirement that if there is
        // no tied output stream, the input is prompted in this way.
        // this ought to be generalized later.
        XSstream& ss = static_cast<XSstream&>(s);
        
        XSstreambuf* buffer = dynamic_cast<XSstreambuf*>(ss.rdbuf());
        buffer->setChannelPrompt(ps);
        
        //ss.m_buf->setChannelPrompt(ps);   
  }
  //## end XSstream::setPrompter%38D29178A0F0.body
}

void XSstream::setPrompter (std::istream& s, const std::string& ps, const std::vector<std::string>& prompts, const std::vector<std::string>& infos)
{
  //## begin XSstream::setPrompter%38E2741F5320.body preserve=yes
  // not yet implemented: for use with scripts.
  //## end XSstream::setPrompter%38E2741F5320.body
}

void XSstream::setLogger (const std::string& name, bool isErr)
{
  //## begin XSstream::setLogger%3B966AE80274.body preserve=yes
        XSstreambuf* buffer = dynamic_cast<XSstreambuf*>(rdbuf());
        buffer->channel()->setLogger(name, isErr);
  //## end XSstream::setLogger%3B966AE80274.body
}

void XSstream::closeLog ()
{
  //## begin XSstream::closeLog%3B968DF2032C.body preserve=yes
        XSstreambuf* buffer = dynamic_cast<XSstreambuf*>(rdbuf());
        buffer->channel()->closeLog();
  //## end XSstream::closeLog%3B968DF2032C.body
}

void XSstream::setVerboseLevel (int console, int log)
{
  //## begin XSstream::setVerboseLevel%3B9D0DAE03BC.body preserve=yes
  m_conVerbose = console;
  m_logVerbose = log;  
  //## end XSstream::setVerboseLevel%3B9D0DAE03BC.body
}

void XSstream::verbose (XSstream& s, int con, int log)
{
  //## begin XSstream::verbose%3BA0D84A035A.body preserve=yes
  int conlevel(con == -1 ? 10 : con);
  int loglevel(log == -1 ? 10 : log);
  s.setVerboseLevel(conlevel,loglevel);
  //## end XSstream::verbose%3BA0D84A035A.body
}

void XSstream::defineChannel (std::ostream& s, XSchannel* chan, std::streamsize bufLen)
{
  //## begin XSstream::defineChannel%3BA20DBF010E.body preserve=yes
  try
  {     XSstream& xsOut = dynamic_cast<XSstream&>(s);
        xsOut.defineChannel(chan,bufLen);
  }
  catch (std::bad_cast)
  {
        throw NotXSstream();       
  } 
        
  //## end XSstream::defineChannel%3BA20DBF010E.body
}

void XSstream::defineChannel (std::istream& s, XSchannel* chan, std::streamsize bufLen)
{
  //## begin XSstream::defineChannel%3BA2126E03CE.body preserve=yes
  try
  {     XSstream& xsIn = dynamic_cast<XSstream&>(s);
        xsIn.defineChannel(chan,bufLen);
  }
  catch (std::bad_cast)
  {
        throw NotXSstream();       
  }       
  //## end XSstream::defineChannel%3BA2126E03CE.body
}

int XSstream::maxChatter ()
{
  //## begin XSstream::maxChatter%3F32698F02CF.body preserve=yes
  return std::max(m_consoleChatterLevel,m_logChatterLevel);
  //## end XSstream::maxChatter%3F32698F02CF.body
}

XSchannel* XSstream::getChannel ()
{
  //## begin XSstream::getChannel%424ACD6A037A.body preserve=yes
   XSstreambuf* buffer = dynamic_cast<XSstreambuf*>(rdbuf());
   return buffer->channel();
  //## end XSstream::getChannel%424ACD6A037A.body
}

// Additional Declarations
  //## begin XSstream%389887EE8DE0.declarations preserve=yes
  //## end XSstream%389887EE8DE0.declarations

// Class XSchannel::LogFileOpenFailure 

XSchannel::LogFileOpenFailure::LogFileOpenFailure (const std::string& diag)
  //## begin XSchannel::LogFileOpenFailure::LogFileOpenFailure%3B969CD903A1.hasinit preserve=yes
  : YellowAlert(" cannot open log file: ")
  //## end XSchannel::LogFileOpenFailure::LogFileOpenFailure%3B969CD903A1.hasinit
  //## begin XSchannel::LogFileOpenFailure::LogFileOpenFailure%3B969CD903A1.initialization preserve=yes
  //## end XSchannel::LogFileOpenFailure::LogFileOpenFailure%3B969CD903A1.initialization
{
  //## begin XSchannel::LogFileOpenFailure::LogFileOpenFailure%3B969CD903A1.body preserve=yes
  *IosHolder::errHolder() << diag << '\n';
  //## end XSchannel::LogFileOpenFailure::LogFileOpenFailure%3B969CD903A1.body
}


// Class XSchannel 

XSchannel::XSchannel()
  //## begin XSchannel::XSchannel%389888C147C0_const.hasinit preserve=no
  //## end XSchannel::XSchannel%389888C147C0_const.hasinit
  //## begin XSchannel::XSchannel%389888C147C0_const.initialization preserve=yes
  //## end XSchannel::XSchannel%389888C147C0_const.initialization
{
  //## begin XSchannel::XSchannel%389888C147C0_const.body preserve=yes
  //## end XSchannel::XSchannel%389888C147C0_const.body
}


XSchannel::~XSchannel()
{
  //## begin XSchannel::~XSchannel%389888C147C0_dest.body preserve=yes
  //## end XSchannel::~XSchannel%389888C147C0_dest.body
}



//## Other Operations (implementation)
void XSchannel::setPrompt (const std::string& ps)
{
  //## begin XSchannel::setPrompt%38D2B151FD98.body preserve=yes
  // default implementation: do nothing;
  //## end XSchannel::setPrompt%38D2B151FD98.body
}

void XSchannel::prompts (const std::string& script, const std::vector<std::string>& prompts, const std::vector<std::string>& infos)
{
  //## begin XSchannel::prompts%38E272296B48.body preserve=yes
  // default implementation: do nothing;
  //## end XSchannel::prompts%38E272296B48.body
}

void XSchannel::setLogger (const std::string& name, bool isErr)
{
  //## begin XSchannel::setLogger%3B966E970121.body preserve=yes
        internalSetLogger(name, isErr);
  //## end XSchannel::setLogger%3B966E970121.body
}

void XSchannel::closeLog ()
{
  //## begin XSchannel::closeLog%3B968E3B0330.body preserve=yes
        internalCloseLog();
  //## end XSchannel::closeLog%3B968E3B0330.body
}

size_t XSchannel::logVerbose () const
{
  //## begin XSchannel::logVerbose%3B9D160600E9.body preserve=yes
  return m_stream->logVerbose();
  //## end XSchannel::logVerbose%3B9D160600E9.body
}

size_t XSchannel::conVerbose () const
{
  //## begin XSchannel::conVerbose%3B9D16260319.body preserve=yes
  return m_stream->conVerbose();
  //## end XSchannel::conVerbose%3B9D16260319.body
}

int XSchannel::toDevice (const char* s, std::streamsize n)
{
  //## begin XSchannel::toDevice%3BA666A30212.body preserve=yes
  if (write(s,n) != n) return -1;
  else return 0;
  //## end XSchannel::toDevice%3BA666A30212.body
}

// Additional Declarations
  //## begin XSchannel%389888C147C0.declarations preserve=yes
  //## end XSchannel%389888C147C0.declarations

//## begin module%38CD1AF1E4F8.epilog preserve=yes
//## end module%38CD1AF1E4F8.epilog
